poj Prime Path BFS

Prime Path
Time Limit: 1000MS   Memory Limit: 65536K
Total Submissions: 7550   Accepted: 4281

Description

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. 
— It is a matter of security to change such things every now and then, to keep the enemy in the dark. 
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know! 
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door. 
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime! 
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds. 
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime. 

Now, the minister of finance, who had been eavesdropping, intervened. 
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound. 
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you? 
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above. 
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

3
1033 8179
1373 8017
1033 1033

Sample Output

6
7
0

简单的BFS题,分别改变一个四位数的个、十、百、千位即可:
代码:
View Code
  1 #include <stdio.h>
  2 #include <iostream>
  3 #include <string.h>
  4 using namespace std;
  5 
  6 
  7 struct M{
  8     int num;
  9     int step;
 10 };
 11 
 12 bool prime(int x)
 13 {
 14     int i,j;
 15     for(i=2;i*i<=x;i++)
 16     {
 17         if(x%i==0) 
 18             return false;
 19     }
 20     return true;
 21 }
 22 
 23 int BFS(int a, int b)
 24 {
 25     M queue[100000];
 26     bool vis[100000]={false};
 27     int i,j;
 28     int head,tail;
 29     head=tail=0;
 30     queue[0].num=a;
 31     queue[tail++].step=0;
 32     while(head<tail)
 33     {
 34         M x=queue[head++];
 35         if(x.num==b)
 36         {
 37             return x.step;
 38         }
 39         int aft;
 40         for(i=1;i<=9;i++)        //改变个位
 41         {
 42             if(!vis[x.num/10*10+i] && prime(x.num/10*10+i)==true)
 43             {
 44                 vis[x.num/10*10+i]=true;
 45                 queue[tail].num=x.num/10*10+i;
 46                 queue[tail++].step=x.step+1;
 47                 //cout<<x.num/10*10+i<<"....."<<endl;
 48             }
 49         }
 50         for(i=0;i<=9;i++)        //改变十位    
 51         {
 52             aft=x.num%10+x.num/100*100+i*10;
 53             if(!vis[aft] && prime(aft))
 54             {
 55                 vis[aft]=true;
 56                 queue[tail].num=aft;
 57                 queue[tail++].step=x.step+1;
 58                 //cout<<aft<<"......"<<endl;
 59             }
 60         }
 61         for(i=0;i<=9;i++)        //改变百位
 62         {
 63             aft=x.num%100+x.num/1000*1000+i*100;
 64             if(!vis[aft] && prime(aft))
 65             {
 66                 vis[aft]=true;
 67                 queue[tail].num=aft;
 68                 queue[tail++].step=x.step+1;
 69                 //cout<<aft<<"....."<<endl;
 70             }
 71         }
 72         for(i=1;i<=9;i++)      //改变千位
 73         {
 74             aft=x.num%1000+i*1000;
 75             if(!vis[aft] && prime(aft))
 76             {
 77                 vis[aft]=true;
 78                 queue[tail].num=aft;
 79                 queue[tail++].step=x.step+1;
 80                 //cout<<aft<<"......"<<endl;
 81             }
 82         }
 83     }
 84     return 0;
 85 }
 86 
 87 int main()
 88 {
 89     int t;
 90     int i,j,k;
 91     scanf("%d",&t);
 92     while(t--)
 93     {
 94         int n;
 95         int m;
 96         scanf("%d%d",&n,&m);
 97         printf("%d\n",BFS(n,m));
 98     }
 99     return 0;
100 }
原文地址:https://www.cnblogs.com/shenshuyang/p/2615369.html